VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommonDialogs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim OFName As OPENFILENAME

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub MemoryCopy Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
Private Declare Function PRINTDLG Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function privateFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function privateLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function privateUnlock Lib "kernel32" (ByVal hMem As Long) As Long

Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32

Private Type DEVMODE
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type

Private Type DEVNAMES
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
End Type

Private Type PRINTDLG
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        hdc As Long
        flags As Long
        nFromPage As Integer
        nToPage As Integer
        nMinPage As Integer
        nMaxPage As Integer
        nCopies As Integer
        hInstance As Long
        lCustData As Long
        lpfnPrintHook As Long
        lpfnSetupHook As Long
        lpPrintTemplateName As String
        lpSetupTemplateName As String
        hPrintTemplate As Long
        hSetupTemplate As Long
End Type

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type CHOOSECOLOR
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        rgbResult As Long
        lpCustColors As Long
        flags As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Private Const CC_ENABLEHOOK = &H10
Private Const CC_ENABLETEMPLATE = &H20
Private Const CC_ENABLETEMPLATEHANDLE = &H40
Private Const CC_FULLOPEN = &H2
Private Const CC_PREVENTFULLOPEN = &H4
Private Const CC_RGBINIT = &H1
Private Const CC_SHOWHELP = &H8

Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_EXPLORER = &H80000
Private Const GMEM_MOVEABLE = &H2
Private Const GMEM_ZEROINIT = &H40
Private Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)

Private Const PD_ALLPAGES = &H0
Private Const PD_SELECTION = &H1
Private Const PD_PAGENUMS = &H2
Private Const PD_NOSELECTION = &H4
Private Const PD_NOPAGENUMS = &H8
Private Const PD_COLLATE = &H10
Private Const PD_PRINTTOFILE = &H20
Private Const PD_PRINTSETUP = &H40
Private Const PD_NOWARNING = &H80
Private Const PD_RETURNDC = &H100
Private Const PD_RETURNIC = &H200
Private Const PD_RETURNDEFAULT = &H400
Private Const PD_SHOWHELP = &H800
Private Const PD_ENABLEPRINTHOOK = &H1000
Private Const PD_ENABLESETUPHOOK = &H2000
Private Const PD_ENABLEPRINTTEMPLATE = &H4000
Private Const PD_ENABLESETUPTEMPLATE = &H8000
Private Const PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
Private Const PD_ENABLESETUPTEMPLATEHANDLE = &H20000
Private Const PD_USEDEVMODECOPIES = &H40000
Private Const PD_DISABLEPRINTTOFILE = &H80000
Private Const PD_HIDEPRINTTOFILE = &H100000
Private Const DN_DEFAULTPRN = &H1

Public Function ShowOpen(ByVal OwnderhWnd As Long, ByVal Title As String, ByVal Filter As String, FilterIndex As Integer, Optional initDir As String, Optional bolMultiSelect As Boolean = False) As String

OFName.lStructSize = Len(OFName)
OFName.hwndOwner = OwnderhWnd
OFName.hInstance = App.hInstance
OFName.lpstrFilter = Replace(Filter, "|", Chr(0))
OFName.nFilterIndex = FilterIndex
OFName.lpstrFile = Space$(254)
OFName.nMaxFile = 255
OFName.lpstrFileTitle = Space$(254)
OFName.nMaxFileTitle = 255
OFName.lpstrInitialDir = initDir
OFName.lpstrTitle = Title
If bolMultiSelect Then
    OFName.flags = OFN_ALLOWMULTISELECT Or OFN_FILEMUSTEXIST Or OFN_EXPLORER Or OFN_HIDEREADONLY
Else
    OFName.flags = OFN_EXPLORER Or OFN_HIDEREADONLY
End If
    
If GetOpenFileName(OFName) Then
    ShowOpen = Trim$(OFName.lpstrFile)
Else
    ShowOpen = "-1"
End If
    
End Function

Public Function ShowSave(OwnderhWnd As Long, Title As String, Filter As String, defExt As String, Optional initDir As String) As String

OFName.lStructSize = Len(OFName)
OFName.hwndOwner = OwnderhWnd
OFName.hInstance = App.hInstance
OFName.lpstrFilter = Replace(Filter, "|", Chr(0))
OFName.lpstrFile = Space$(254)
OFName.nMaxFile = 255
OFName.lpstrFileTitle = Space$(254)
OFName.nMaxFileTitle = 255
OFName.lpstrInitialDir = initDir
OFName.lpstrTitle = Title
OFName.flags = OFN_OVERWRITEPROMPT
OFName.lpstrDefExt = defExt

If GetSaveFileName(OFName) Then
    ShowSave = Trim$(OFName.lpstrFile)
Else
    ShowSave = -1
End If

End Function

Public Function ShowColor(hwnd As Long) As Long

Dim C As CHOOSECOLOR
Dim Address As Long
Dim Memhandle As Long, wSize As Long
Dim i As Integer
Dim result As Long
ReDim ClrArray(15) As Long

wSize = Len(ClrArray(0)) * 16
Memhandle = GlobalAlloc(GHND, wSize)
If Memhandle = 0 Then Exit Function
Address = GlobalLock(Memhandle)

For i = 0 To UBound(ClrArray)
    ClrArray(i) = &HFFFFFF
Next

MemoryCopy ByVal Address, ClrArray(0), wSize

C.lStructSize = Len(C)
C.hwndOwner = hwnd
C.lpCustColors = Address

C.flags = CC_RGBINIT Or CC_FULLOPEN

result = CHOOSECOLOR(C)

MemoryCopy ClrArray(0), ByVal Address, wSize

GlobalUnlock Memhandle
GlobalFree Memhandle

If result = 0 Then
    ShowColor = -1
Else
    ShowColor = C.rgbResult
End If

End Function

Public Sub ShowPrinterDoc(hwnd As Long)
    
Dim lngAddress As Long
Dim P As PRINTDLG
Dim D As DEVMODE
Dim result As Long
Dim lngRetVal As Long
Dim wSize As Long
    
P.lStructSize = Len(P)
P.hwndOwner = hwnd
P.flags = PD_RETURNIC
P.nFromPage = 1
P.nToPage = 12
P.nMinPage = 1
P.nMaxPage = 12
P.nCopies = 1
result = PRINTDLG(P)
    
If result = 0 Then Exit Sub
If P.hdc <> 0 Then lngRetVal = DeleteDC(P.hdc)
If P.hDevNames <> 0 Then lngRetVal = privateFree(P.hDevNames)
lngAddress = privateLock(P.hDevMode)
MemoryCopy D, ByVal lngAddress, Len(D)
lngRetVal = privateUnlock(P.hDevMode)
lngRetVal = privateFree(P.hDevMode)

End Sub

Public Sub ShowPrinter(hwnd As Long)
    
Dim lngResult As Long
Dim lngRetVal As Long

Dim Address As Long
Dim P As PRINTDLG
Dim D As DEVMODE
Dim Memhandle As Long, wSize As Long

P.lStructSize = Len(P)
P.hwndOwner = hwnd
P.flags = PD_PRINTSETUP
lngResult = PRINTDLG(P)
    
If lngResult = 0 Then Exit Sub
If P.hdc <> 0 Then lngRetVal = DeleteDC(P.hdc)
If P.hDevNames <> 0 Then lngRetVal = GlobalFree(P.hDevNames)
Address = GlobalLock(P.hDevMode)
Call MemoryCopy(D, ByVal Address, Len(D))

lngRetVal = GlobalUnlock(P.hDevMode)
lngRetVal = GlobalFree(P.hDevMode)

Debug.Print "Printer:", Left$(D.dmDeviceName, InStr(D.dmDeviceName, Chr$(0)) - 1)
Debug.Print "Orientation:", D.dmOrientation

Printer.Duplex = D.dmDuplex
Printer.Orientation = D.dmOrientation

End Sub
