VERSION 5.00
Begin VB.Form frmTemplateBearbeiten 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Template bearbeiten"
   ClientHeight    =   3285
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8445
   Icon            =   "frmTemplateBearbeiten.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3285
   ScaleWidth      =   8445
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox txtLinks 
      Height          =   915
      Left            =   3720
      MaxLength       =   5000
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   5
      Top             =   360
      Width           =   4575
   End
   Begin VB.TextBox txtRechts 
      Height          =   915
      Left            =   3720
      MaxLength       =   5000
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   4
      Top             =   1680
      Width           =   4575
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "Speichern"
      Default         =   -1  'True
      Height          =   375
      Left            =   6600
      TabIndex        =   3
      Top             =   2760
      Width           =   1695
   End
   Begin VB.CommandButton cmdAbbrechen 
      Cancel          =   -1  'True
      Caption         =   "Abbrechen"
      Height          =   375
      Left            =   5160
      TabIndex        =   2
      Top             =   2760
      Width           =   1335
   End
   Begin VB.ListBox lstTemplates 
      Height          =   2205
      ItemData        =   "frmTemplateBearbeiten.frx":058A
      Left            =   120
      List            =   "frmTemplateBearbeiten.frx":058C
      TabIndex        =   0
      Top             =   360
      Width           =   3375
   End
   Begin VB.Label lblLinks 
      Caption         =   "Text links vom Cursor"
      Height          =   195
      Left            =   3720
      TabIndex        =   7
      Top             =   120
      Width           =   1515
   End
   Begin VB.Label lblRechts 
      Caption         =   "Text rechts vom Cursor"
      Height          =   195
      Left            =   3720
      TabIndex        =   6
      Top             =   1440
      Width           =   1635
   End
   Begin VB.Label lblTemplates 
      Caption         =   "Verfgbare Templates"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1560
   End
End
Attribute VB_Name = "frmTemplateBearbeiten"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdAbbrechen_Click()

Unload Me

End Sub

Private Sub Form_Load()

ReadIn

End Sub

Private Sub Form_Unload(Cancel As Integer)

TemplatesLaden

End Sub

Public Sub ReadIn()

lstTemplates.Clear

Dim File$, hFile&, FD As WIN32_FIND_DATA

hFile = FindFirstFile(app.Path & "\templates\*.*", FD)

If hFile = 0 Then Exit Sub

Do
    File = Left$(FD.cFileName, InStr(FD.cFileName, Chr(0)) - 1)
   If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY Then
        If (File <> ".") And (File <> "..") Then
            lstTemplates.AddItem File
        End If
   End If
   
Loop While FindNextFile(hFile, FD)

Call FindClose(hFile)

End Sub

Private Sub lstTemplates_Click()

On Error GoTo Ende

Dim DateiNr As Long
Dim Template As Template

DateiNr = FreeFile

Open app.Path & "\templates\" & lstTemplates.List(lstTemplates.ListIndex) For Random As DateiNr
    Get #DateiNr, , Template
Close DateiNr

txtLinks.Text = Template.strLinks
txtRechts.Text = Template.strRechts

Ende:

End Sub


Private Sub cmdOK_Click()

On Error GoTo Ende

If lstTemplates.List(lstTemplates.ListIndex) = "" Then
    Unload Me
    Exit Sub
End If

Dim newTemplate As Template
Dim DateiNr As Long

If txtLinks.Text = "" And txtRechts.Text = "" Then
    MsgBox "Bitte einen Text eingeben !", vbInformation, "Template"
    Exit Sub
End If

newTemplate.strName = lstTemplates.List(lstTemplates.ListIndex)
newTemplate.strLinks = txtLinks.Text
newTemplate.strRechts = txtRechts.Text

DateiNr = FreeFile

Open app.Path & "\templates\" & lstTemplates.List(lstTemplates.ListIndex) For Random As DateiNr
    Put #DateiNr, , newTemplate
Close DateiNr

TemplatesLaden

Unload Me

Exit Sub
Ende:

If MsgBox("Das templates-Verzeichnis im Programmordner wurde nicht gefunden, soll es angelegt werden ?", vbQuestion) = vbYes Then
    MkDir app.Path & "\templates"
End If

End Sub

