VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmChild 
   ClientHeight    =   6600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9120
   Icon            =   "frmChild.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   6600
   ScaleWidth      =   9120
   WindowState     =   2  'Maximiert
   Begin VB.ListBox lstIntelliSense 
      Appearance      =   0  '2D
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   1395
      ItemData        =   "frmChild.frx":058A
      Left            =   120
      List            =   "frmChild.frx":058C
      Sorted          =   -1  'True
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   120
      Visible         =   0   'False
      Width           =   4365
   End
   Begin RichTextLib.RichTextBox rtfText 
      Height          =   6615
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   9135
      _ExtentX        =   16113
      _ExtentY        =   11668
      _Version        =   393217
      BackColor       =   16777215
      BorderStyle     =   0
      Enabled         =   -1  'True
      HideSelection   =   0   'False
      ScrollBars      =   2
      TextRTF         =   $"frmChild.frx":058E
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmChild"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public cUndo As clsUndo
Public bolLocked As Boolean
Private bolAdd As Boolean
Private bolKeyPressed As Boolean
Public cActualState As clsUndoElement

Public bolGendert As Boolean
Public FindString As String                     'Fr Suche
Public FOpt As Integer                          ' "    "
Public StartPos As Long                         ' "    "

Private cIntelliSense As clsIntelliSense

Private Sub Form_Load()

Set cUndo = New clsUndo

frmMain.EnDisableButtons

If CBool(frmMain.clsOptions.GetSetting(WordWrap)) = True Then
    SendMessageLong rtfText.hwnd, EM_SETTARGETDEVICE, 0, 0
    Else: SendMessageLong rtfText.hwnd, EM_SETTARGETDEVICE, 0, 1
End If

Set cIntelliSense = New clsIntelliSense

rtfText.Font.Name = frmMain.clsOptions.GetSetting(Schriftart)
rtfText.Font.Size = frmMain.clsOptions.GetSetting(Schriftgre)

GetActualState

End Sub

Public Sub GetActualState()

Set cActualState = Nothing
Set cActualState = New clsUndoElement

cActualState.lngFirstVisibleLine = SendMessage(rtfText.hwnd, EM_GETFIRSTVISIBLELINE, 0, 0)
cActualState.lngSelStart = rtfText.SelStart
cActualState.strUndoText = rtfText.Text

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

Dim intCancel As Integer

If Me.bolGendert = True Then
    If UnloadMode = vbFormControlMenu Or vbFormCode Then
        intCancel = MsgBox("Sollen die nderungen in " & Me.caption & " gespeichert werden ?", vbQuestion Or vbYesNoCancel, "Schlieen")
        If intCancel = 2 Then
            Cancel = True
        ElseIf intCancel = 6 Then
            Save
        End If
    End If
End If

End Sub

Private Sub Form_Resize()

rtfText.Move 0, 0, Me.Width - 120, Me.Height - 400

End Sub

Private Sub Form_Unload(Cancel As Integer)

Dim n As Long

For n = 1 To cUndo.mvarcolUndo.Count
    cUndo.mvarcolUndo.Remove cUndo.mvarcolUndo.Count
Next

For n = 1 To cUndo.mvarcolRedo.Count
    cUndo.mvarcolRedo.Remove cUndo.mvarcolRedo.Count
Next

Set cUndo = Nothing

colDokumente.Remove Me.caption
frmMain.RefreshWindowList
frmMain.EnDisableButtons

End Sub

Private Sub Form_Activate()

Dim strTempDir As String

frmMain.EnDisableButtons

If InStr(Me.caption, "(Unbenannt") = 0 Then
    strTempDir = Left(Me.caption, InStrRev(Me.caption, "\") - 1)
    If frmMain.Explorer.Pfad <> strTempDir Then
        frmMain.Explorer.Pfad = strTempDir
    End If
End If

End Sub

Private Sub Form_Deactivate()

frmMain.EnDisableButtons

End Sub

Private Sub rtfText_Change()

On Error GoTo Ende
Dim Tag As String
Dim lngTemp As Long
Dim n As Integer
Dim bytSetting As Byte
Dim lngTagStart As Long

Static strTag As String

Const SP = 3&
Dim R As RECT
Dim P As POINTAPI
Dim Lx&, Ly&

Dim cUndoElement As clsUndoElement

If bolKeyPressed = True And bolAdd = False Then
     GoTo Weiter
End If

If Not bolLocked Then
    Set cUndoElement = New clsUndoElement
    cUndoElement.lngSelStart = rtfText.SelStart
    cUndoElement.strUndoText = rtfText.Text
    cUndoElement.lngFirstVisibleLine = SendMessage(rtfText.hwnd, EM_GETFIRSTVISIBLELINE, 0, 0)
    cUndo.mvarcolUndo.Add cUndoElement
    Set cUndoElement = Nothing
End If

Weiter:

GetActualState
bolAdd = False
bolKeyPressed = False

frmMain.EnDisableButtons
  
If CBool(frmMain.clsOptions.GetSetting(IntelliSenseAktiviert)) = True Then
    Call GetCaretPos(P)

    Lx = rtfText.Left + (P.X + SP) * Screen.TwipsPerPixelX + 20

    Ly = rtfText.Top + (P.Y + R.Bottom + SP * (0.6 * rtfText.Font.Size)) * Screen.TwipsPerPixelY

    If Ly + lstIntelliSense.Height > rtfText.Height Then
        Ly = rtfText.Top + P.Y * Screen.TwipsPerPixelY - lstIntelliSense.Height
    End If

    If Lx + lstIntelliSense.Width > rtfText.Width Then
        Lx = rtfText.Width - lstIntelliSense.Width
    End If

    lstIntelliSense.Left = Lx
    lstIntelliSense.Top = Ly
    lngTagStart = InStrRev(rtfText.Text, "<", rtfText.SelStart)

    Tag = Mid$(rtfText.Text, lngTagStart, rtfText.SelStart - lngTagStart)

    If Mid$(rtfText.Text, rtfText.SelStart, 1) = ">" Then
        Tag = ""
    End If

    If InStrRev(rtfText.Text, "=", rtfText.SelStart) > InStrRev(rtfText.Text, " ", rtfText.SelStart) Then Tag = ""
    If InStrRev(Tag, "=" & Chr(34)) > InStrRev(Tag, Chr(34) & " ") Then
        If Right(Tag, 1) <> Chr(34) Then Tag = ""
    End If

    If InStr(Mid$(rtfText.Text, lngTagStart, rtfText.SelStart - lngTagStart), ">") > 0 Then Tag = ""
    If Trim(Tag) = "" Then Tag = ""
    cIntelliSense.Tag = Tag

    lngTemp = cIntelliSense.TagAttribute.Count

    If strTag <> cIntelliSense.strErkannterTag Then
        lstIntelliSense.Clear
        
        For n = 1 To cIntelliSense.TagAttribute.Count
            lstIntelliSense.AddItem LCase(cIntelliSense.TagAttribute.Item(n))
        Next

    End If

    If lstIntelliSense.ListCount <> 0 Then
        lstIntelliSense.Visible = True
        lstIntelliSense.ZOrder 0
        ListFindText lstIntelliSense, Mid$(rtfText.Text, InStrRev(rtfText.Text, " ", rtfText.SelStart) + 1, rtfText.SelStart - InStrRev(rtfText.Text, " ", rtfText.SelStart)), , True
    Else: lstIntelliSense.Visible = False
        lstIntelliSense.ZOrder 1
    End If

    strTag = cIntelliSense.strErkannterTag
End If

Ende:
bolGendert = True

End Sub

Public Sub Undo()

Dim cTempUndoElement As clsUndoElement
Set cTempUndoElement = cUndo.Undo()

bolLocked = True
SendMessage rtfText.hwnd, WM_SETREDRAW, 0, 0
rtfText.Text = cTempUndoElement.strUndoText
GotoLine cTempUndoElement.lngFirstVisibleLine + 1
rtfText.SelStart = cTempUndoElement.lngSelStart
SendMessage rtfText.hwnd, WM_SETREDRAW, 1, 0

Set cTempUndoElement = Nothing
bolLocked = False
GetActualState

End Sub

Public Sub Redo()

Dim cTempUndoElement As clsUndoElement
Set cTempUndoElement = cUndo.Redo()

bolLocked = True
SendMessage rtfText.hwnd, WM_SETREDRAW, 0, 0
rtfText.Text = cTempUndoElement.strUndoText
GotoLine cTempUndoElement.lngFirstVisibleLine + 1
rtfText.SelStart = cTempUndoElement.lngSelStart
SendMessage rtfText.hwnd, WM_SETREDRAW, 1, 0
Set cTempUndoElement = Nothing
bolLocked = False
GetActualState

End Sub

Public Sub Save()

On Error GoTo Fehlerbehandlung

Dim lngFileNr As Long

If InStr(Me.caption, "(Unbenannt") = 0 Then
    UpdateDates
    lngFileNr = FreeFile
    If CBool(frmMain.clsOptions.GetSetting(UmlautKonvertierung)) = True Then ConvEntities False
    Open caption For Output As lngFileNr
    Print #lngFileNr, rtfText.Text
    Close lngFileNr
    'rtfText.SaveFile caption, 1
    bolGendert = False
Else
    SaveAs
End If

Exit Sub

Fehlerbehandlung:
If Err.Number = 75 Then
    If MsgBox("Die Datei ist schreibgeschtzt," & vbCrLf & "soll der Schreibschutz aufgehoben werden ?", vbQuestion Or vbYesNo, "Speichern") = vbYes Then
        SetAttr Me.caption, vbNormal
        Resume
    End If
Else
    MsgBox Err.Description, vbInformation
End If

End Sub

Public Sub SaveAs()

On Error GoTo Fehlerbehandlung

Dim lngFileNr As Long
Dim strFileName As String
Dim cCommonDialog As New clsCommonDialogs

strFileName = cCommonDialog.ShowSave(hwnd, "Speicher unter ...", "Alle Dateien (*.*)|*.*", "")
If strFileName = "-1" Then Exit Sub

UpdateDates
lngFileNr = FreeFile
If CBool(frmMain.clsOptions.GetSetting(UmlautKonvertierung)) = True Then ConvEntities False
Open strFileName For Output As lngFileNr
Print #lngFileNr, rtfText.Text
Close lngFileNr
colDokumente.Remove Me.caption
Me.caption = strFileName
colDokumente.Add Me, Me.caption
frmMain.RefreshWindowList
bolGendert = False

Exit Sub
Fehlerbehandlung:

If Err.Number = 75 Then
        If MsgBox("Die Datei ist schreibgeschtzt," & vbCrLf & "soll der Schreibschutz aufgehoben werden ?", vbQuestion Or vbYesNo, "Speichern") = vbYes Then
        SetAttr Me.caption, vbNormal
        Resume
    End If
Else
    MsgBox Err.Description
End If

End Sub

Public Sub BackUp()

If InStr(Me.caption, "(Unbenannt") > 0 Then
    MsgBox "Die Datei muss erst gespeichert werden !", vbInformation, "Backup"
    Exit Sub
End If

rtfText.SaveFile Me.caption & ".bak", 1

End Sub

Public Sub PrintText()

'Dim cCommonDialog As New clsCommonDialogs
'cCommonDialog.ShowPrinter hwnd
frmPrinter.Show vbModal
'Printer.Print rtfText.Text       'Text ausdrucken
'Printer.EndDoc                   'Drucker schlieen


End Sub

Public Sub SaveSelection()

Dim intDateiNr As Integer

Dim strFileName As String
Dim cCommonDialog As New clsCommonDialogs

strFileName = cCommonDialog.ShowSave(hwnd, "Speicher unter ...", "Alle Dateien (*.*)|*.*", "")
If strFileName = "-1" Then Exit Sub

intDateiNr = FreeFile

Open strFileName For Output As intDateiNr
    Print #intDateiNr, rtfText.SelText
Close

Ende:

End Sub

Private Sub rtfText_OLECompleteDrag(Effect As Long)

cUndo.mvarcolUndo.Add cActualState
Set cActualState = Nothing
bolAdd = False

End Sub

Private Sub rtfText_KeyDown(KeyCode As Integer, Shift As Integer)

' undo

bolAdd = False
bolKeyPressed = True

If KeyCode = vbKeySpace Or KeyCode = vbKeyReturn Or KeyCode = vbKeyDelete Or KeyCode = vbKeyBack Then
    bolAdd = True
End If

'## IntelliSense

If Shift = 2 Then
    Select Case KeyCode
        
        Case vbKeyReturn
        Paste "<BR />", True, False
        KeyCode = 0
        
        Case vbKeySpace
        Paste "&nbsp;", True, False
        KeyCode = 0
    End Select
End If

If lstIntelliSense.Visible = False Then GoTo Weiter

Const LB_SETCURSEL = &H186
Const CB_SETCURSEL = &H14E

If CBool(frmMain.clsOptions.GetSetting(IntelliSenseAktiviert)) = True Then
    If KeyCode = vbKeyRight Or KeyCode = vbKeyTab Then
        If lstIntelliSense.ListIndex <> -1 Then
            lstintellisense_Click
            KeyCode = 0
        End If
    End If
    
    On Error GoTo Ende

    If KeyCode = vbKeyDown And lstIntelliSense.Visible = True Then
        If lstIntelliSense.ListIndex + 1 <> lstIntelliSense.ListCount Then
            SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 0, 0
            SendMessage lstIntelliSense.hwnd, LB_SETCURSEL, lstIntelliSense.ListIndex + 1, 0&
            SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 1, 0
            lstIntelliSense.Refresh
        Else: SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 0, 0
            SendMessage lstIntelliSense.hwnd, LB_SETCURSEL, 0, 0&
            SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 1, 0
            lstIntelliSense.Refresh
        End If
    
        KeyCode = 0
    
    ElseIf KeyCode = vbKeyUp Then
    
        If lstIntelliSense.ListIndex - 1 <> -1 Then
            SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 0, 0
            SendMessage lstIntelliSense.hwnd, LB_SETCURSEL, lstIntelliSense.ListIndex - 1, 0&
            SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 1, 0
            lstIntelliSense.Refresh
        Else: SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 0, 0
            SendMessage lstIntelliSense.hwnd, LB_SETCURSEL, lstIntelliSense.ListCount - 1, 0&
            SendMessage lstIntelliSense.hwnd, WM_SETREDRAW, 1, 0
            lstIntelliSense.Refresh
        End If
        
        KeyCode = 0
    
    End If
End If

Weiter:

'## Ende IntelliSense

Ende:

End Sub


Public Sub Cut()

Clipboard.Clear                      'Zwischenablage lschen
Clipboard.SetText rtfText.SelText    'Markierung der Zwischenablage zuweisen
rtfText.SelText = ""                 'Markierung lschen

ClipBoardChanged

End Sub

Public Sub Copy()

            '############################################
            '# Aufgabe: Kopieren des markierten Textes  #
            '#          in die Zwischenablage           #
            '# Parameter: -                             #
            '# Rckgabewerte: -                         #
            '############################################
            
On Error GoTo Ende
            
Clipboard.Clear                                                'Zwischenablage lschen
Clipboard.SetText (rtfText.SelText)         'Markierung in die Zwischenablage kopieren
ClipBoardChanged

Ende:

End Sub

Public Sub Paste(Optional strText As String, Optional bolTag As Boolean = False, Optional bolNotAddUndoElement As Boolean = False)

If strText = "" And bolTag = False Then
    strText = Clipboard.GetText
End If

If strText = "" Then Exit Sub
            
Dim nSelStart As Long
Dim nSelLength As Long
Dim nInsertSelStart As Long

cUndo.mvarcolUndo.Add cActualState

bolLocked = True

rtfText.SelText = "" 'Markierung lschen

With rtfText
    nSelStart = .SelStart
    nSelLength = .SelLength
    nInsertSelStart = .SelStart
    .SelStart = nInsertSelStart
    .SelText = strText
    .SelAlignment = 0
    
    If CBool(frmMain.clsOptions.GetSetting(TextMarkieren)) = True Then
        .SelStart = nInsertSelStart
        .SelLength = Len(strText)
    Else: .SelAlignment = 0
    
    End If
End With

bolLocked = False

End Sub

Public Sub SelectAll()

rtfText.SelStart = 0
rtfText.SelLength = Len(rtfText.Text)

End Sub

Public Sub SearchNext()

            '#############################################
            '# Aufgabe: Suchen von Text im Textfeld      #
            '# Parameter: -                              #
            '# Rckgabewerte: -                          #
            '#############################################
            
If FindString = "" Then
    frmFindReplace.Show
    Exit Sub
End If

With rtfText

StartPos = .Find(FindString, StartPos, Len(.Text), FOpt) + 1
    
    If StartPos = 0 Then
      MsgBox Chr(34) & FindString & Chr(34) & " kann nicht gefunden werden"
    End If
    
End With

End Sub

Public Sub Preview()

Dim cProjekt As clsProject
Set cProjekt = New clsProject
Dim bolSchonGespeichert As Boolean

If InStr(Me.caption, "(Unbenannt") > 0 Then
    Me.Save
    bolSchonGespeichert = True
End If

If frmMain.clsOptions.GetSetting(PreviewSpeichern) = True Then
    If Not bolSchonGespeichert Then
        Me.Save
    End If
End If


If InStr(Me.caption, "(Unbenannt") = 0 Then
    frmVorschau.Show                          'Previewform zeigen
    cProjekt.ProjectFile = frmMain.strProject
    
    If cProjekt.GetSetting(Open_StartSite) = True Then
        If cProjekt.GetSetting(Startsite) = "" Then
            MsgBox "Es wurde keine Startseite in der  Projektverwaltung angebeben, " & vbCrLf & _
                "aber die Option 'immer Startseite bei Preview ffnen' ist aktiviert !", vbInformation
            Exit Sub
        End If
        frmVorschau.Navigate cProjekt.GetSetting(Startsite)
        frmVorschau.SetFocus
      Else
        frmVorschau.Navigate Me.caption           'Aktuelle Datei anzeigen
        frmVorschau.SetFocus                      'Focus setzen
    End If
    
End If

Set cProjekt = Nothing

End Sub

Public Sub InsertTag(TextLinks As String, TextRechts As String, Optional IgnoreOptions As Boolean = False)

            '##############################################
            '# Aufgabe: Einfgend eines Tags vor und nach #
            '#          dem Cursor (mit Zeilenumbruch)    #
            '# Parameter: Text links vom Cursor, Text     #
            '#            rechts vom Cursor, Textfeld     #
            '# Rckgabewerte: -                           #
            '##############################################
            

Dim schreibmarke As Integer
schreibmarke = rtfText.SelStart                'Cursorpostion sichern

If IgnoreOptions = False Then
    TextLinks = LCase(TextLinks)
    TextRechts = LCase(TextRechts)
End If

rtfText.SelStart = rtfText.SelStart + rtfText.SelLength

Paste TextRechts, True

rtfText.SelStart = schreibmarke                'Text links vom
Paste TextLinks, True, True                    'Cursor einfgen
rtfText.SelStart = schreibmarke + Len(TextLinks)

End Sub

Public Sub InsertHTML(Schlssel)

            '###############################################
            '# Aufgabe: Einfgen des HTML-Codes            #
            '# Parameter: Den Schlssel der Toolbar        #
            '# Rckgabewerte: -                            #
            '###############################################

On Error GoTo Ende

Dim cRelativePaths As clsRelativePaths
Dim strDirName As String
Dim strFileName As String
Dim cCommonDialog As clsCommonDialogs

Select Case Schlssel

    Case "Grundgerst"
    InsertTag "<HTML>" & vbCrLf & vbCrLf & "<HEAD>" & vbCrLf & vbCrLf & "<TITLE></TITLE>" & vbCrLf & vbCrLf & "</HEAD>" & vbCrLf & vbCrLf & "<BODY>" & vbCrLf, _
    vbCrLf & "</BODY>" & vbCrLf & vbCrLf & "</HTML>"
    
    Case "email"
    InsertTag "<A HREF=" & vbQuote & "mailto:" & vbQuote & ">", "</A>"
    
    Case "Link"
    InsertTag "<A HREF=" & vbQuote & vbQuote & ">", "</A>"
    
    Case "LinkAusDatei"
    frmLinkAusDatei.Show vbModal
    
    Case "ExtractLinkOfURLFile"
    Set cCommonDialog = New clsCommonDialogs
    strFileName = cCommonDialog.ShowOpen(hwnd, "ffnen", "URL-Dateien (*.url)|*.url", 0)
    If strFileName = "-1" Then Exit Sub
    ExtractLinkOfURLFile strFileName
    Set cCommonDialog = Nothing
    
    Case "Anker"
    InsertTag "<A ID=" & vbQuote & vbQuote & ">", "</A>"
    
    Case "Bild"
    Set cCommonDialog = New clsCommonDialogs
    strFileName = cCommonDialog.ShowOpen(hwnd, "ffnen", "Alle Dateien (*.*)|*.*", 0)
    If strFileName = "-1" Then Exit Sub
            
    If InStr(Me.caption, "[Unbenannt") > 0 Then
        strFileName = strFileName
    Else
        strDirName = Left$(strFileName, InStrRev(strFileName, "\"))
        Set cRelativePaths = New clsRelativePaths
        cRelativePaths.strSrcPath = Left$(Me.caption, InStrRev(Me.caption, "\"))
        cRelativePaths.strFullPath = strDirName
        strFileName = cRelativePaths.RelativePathGet & Right$(strFileName, Len(strFileName) - InStrRev(strFileName, "\"))
    End If
        
    If LCase(Right$(strFileName, 4)) = ".gif" Then
        InsertTag "<IMG SRC=" & vbQuote & strFileName & vbQuote & " BORDER=0 HEIGHT=" & GetGIFSize(strFileName).Y & " " & "WIDTH=" & GetGIFSize(strFileName).X & ">", ""
    Else
        InsertTag "<IMG SRC=" & vbQuote & strFileName & vbQuote & " BORDER=0>", ""
    End If
        
    Case "Kommentar"
    InsertTag "<!-- ", " -->"
    
    Case "Linie"
    InsertTag "<HR />", ""

End Select

Ende:

End Sub

Public Sub ExtractLinkOfURLFile(Dateiname)

            '###############################################
            '# Aufgabe: Auslesen der URL aus einer URL-    #
            '#          Datei und einfgen dieser als Link #
            '# Parameter: UURL-Datei                       #
            '# Rckgabewerte: -                            #
            '###############################################

Dim DateiNr As Integer
Dim Temp As String
DateiNr = FreeFile                          'DateiNr holen
Dim i As Byte

Open Dateiname For Input As DateiNr

For i = 0 To 1                              'Zweite Zeile auslesen
    Line Input #DateiNr, Temp
Next

Close

InsertTag "A HREF=" & vbQuote & Mid$(Temp, InStr(Temp, "=") + 1, Len(Temp)) & vbQuote & ">", "</A>"

End Sub

Private Sub lstintellisense_Click()

On Error Resume Next

Dim strAttribut As String
Dim strEinfgen As String
Dim bolAdd As Boolean

bolAdd = CBool(frmMain.clsOptions.GetSetting(IntelliSenseIstGleich))
strAttribut = Mid$(rtfText.Text, InStrRev(rtfText.Text, " ", rtfText.SelStart), rtfText.SelStart - InStrRev(rtfText.Text, " ", rtfText.SelStart) + 1)
strEinfgen = Right$(lstIntelliSense.List(lstIntelliSense.ListIndex), Len(lstIntelliSense.List(lstIntelliSense.ListIndex)) - Len(strAttribut) + 1)


If CBool(frmMain.clsOptions.GetSetting(IntelliSenseIstGleich)) = True Then
    If cIntelliSense.strErkannterTag <> "<!doctype" Then
        strEinfgen = strEinfgen & "="""""
    End If
    If Len(strEinfgen) = 1 Then Exit Sub
End If

If InStr(UCase(lstIntelliSense.List(lstIntelliSense.ListIndex)), UCase(Trim(strAttribut))) > 0 Then
    InsertTag strEinfgen, "", True
    If bolAdd = True Then rtfText.SelStart = rtfText.SelStart - 1
Else
    If bolAdd = True Then
        If cIntelliSense.strErkannterTag <> "<!doctype" Then
            strEinfgen = strEinfgen & "="""""
        End If
    End If
    
    If Mid$(rtfText.Text, rtfText.SelStart, 1) = " " Then
        InsertTag strEinfgen, ""
    Else
        InsertTag " " & strEinfgen, "", True
    End If
    
    If bolAdd = True Then rtfText.SelStart = rtfText.SelStart - 1
        
End If

lstIntelliSense.Visible = False

End Sub

Public Sub IncludeCSS(Dateiname)

            '###############################################
            '# Aufgabe: Einbinden einer CSS                #
            '# Parameter: Dateiname der CSS                #
            '# Rckgabewerte: -                            #
            '###############################################
                    
If InStr(rtfText.Text, "<HEAD>") <> 0 Then rtfText.SelStart = InStr(rtfText.Text, "<HEAD>") + 5
InsertTag vbCrLf & vbCrLf & "<LINK REL=stylesheet HREF=" & vbQuote & Dateiname & vbQuote & " TYPE" & vbQuote & "=text/css" & vbQuote & ">", ""
           
End Sub



Private Sub rtfText_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

If Button = vbRightButton Then
    With frmMain
        .mnuKontextEinfgen.Enabled = (Clipboard.GetText <> "")
        .mnuKontextAusschneiden.Enabled = (rtfText.SelText <> "")
        .mnuKontextKopieren.Enabled = (rtfText.SelText <> "")
        .mnuKontextRedo.Enabled = (cUndo.mvarcolRedo.Count <> 0)
        .mnuKontextUndo.Enabled = (cUndo.mvarcolUndo.Count <> 0)
    End With
    PopupMenu frmMain.mnuKontext
End If

End Sub

Sub UpdateStatusBar()

            '##############################################
            '# Aufgabe: Aktualisieren der Statusbar in    #
            '#          frmMain. Zum Beispiel Zeilen-     #
            '#          Nummer und Zeichennummer          #
            '# Parameter: -                               #
            '# Rckgabewerte: -                           #
            '##############################################

Dim ZeileMax&
ZeileMax = SendMessage(rtfText.hwnd, EM_GETLINECOUNT, 0, 0&)

Dim X&, Y&
Y = SendMessage(rtfText.hwnd, EM_LINEFROMCHAR, rtfText.SelStart, 0&) + 1
  
X = rtfText.SelStart - SendMessage(rtfText.hwnd, EM_LINEINDEX, Y - 1, 0&)
                   
frmMain.staStatus.Panels(3).Text = X
frmMain.staStatus.Panels.Item(2).Text = Y

End Sub

Private Sub rtfText_SelChange()

UpdateStatusBar

End Sub


Public Sub GotoLine(Optional Y As Long = -1)

On Error GoTo Ende

Dim lngZeilenNr As Long
Dim lngMaxLines As Long

lngMaxLines = SendMessage(rtfText.hwnd, EM_GETLINECOUNT, 0, 0)
If Y = -1 Then
    lngZeilenNr = InputBox("Bitte Zeilennummer eingeben:", "Gehe zu Zeile ...")
Else
    lngZeilenNr = Y
End If

If lngZeilenNr > lngMaxLines Or IsNumeric(lngZeilenNr) = False Or lngZeilenNr < 1 Then
    MsgBox "Ungltige Zeilennummer !", vbInformation, "Gehe zu Zeile ..."
    Exit Sub
End If

SendMessage rtfText.hwnd, WM_SETREDRAW, 0, 0
rtfText.SelStart = 0
SendMessage rtfText.hwnd, EM_LINESCROLL, 0, ByVal lngZeilenNr - 1
SendMessage rtfText.hwnd, WM_SETREDRAW, 1, 0
rtfText.Refresh
rtfText.SetFocus
UpdateStatusBar

Ende:

End Sub

Public Sub GoToPerlSub(strSubName As String)

Dim lngPos As Long
Dim Y As Long

lngPos = InStr(rtfText.Text, "sub " & strSubName)
rtfText.SelStart = lngPos - 1
Y = SendMessage(rtfText.hwnd, EM_LINEFROMCHAR, rtfText.SelStart, 0&) + 1

GotoLine Y

End Sub

Private Sub rtftext_DragDrop(Source As Control, X As Single, Y As Single)

Paste frmMain.txtItem.Text

End Sub

Public Sub ConvEntities(Load As Boolean)

If UCase(Right(caption, 4)) = ".HTM" Or UCase(Right(caption, 5)) = ".HTML" Or UCase(Right(caption, 6)) = ".SHTML" Then
    
    If Load Then
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
        rtfText.Text = Replace(rtfText.Text, UmlautToHTML(""), "")
    Else
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
        rtfText.Text = Replace(rtfText.Text, "", UmlautToHTML(""))
    End If
End If

End Sub
