VERSION 5.00
Begin VB.Form frmColorPicker 
   AutoRedraw      =   -1  'True
   BorderStyle     =   0  'Kein
   ClientHeight    =   2715
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4170
   DrawMode        =   6  'Stift und inverse Anzeige maskieren
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   MousePointer    =   2  'Kreuz
   ScaleHeight     =   2715
   ScaleWidth      =   4170
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox picLupe 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   2055
      Left            =   0
      ScaleHeight     =   2055
      ScaleWidth      =   2175
      TabIndex        =   0
      Top             =   0
      Width           =   2175
      Begin VB.Line lineFadenkreuzV 
         BorderColor     =   &H00000000&
         DrawMode        =   6  'Stift und inverse Anzeige maskieren
         X1              =   0
         X2              =   2160
         Y1              =   960
         Y2              =   960
      End
      Begin VB.Line lineFadenkreuzH 
         BorderColor     =   &H00C0C0C0&
         DrawMode        =   6  'Stift und inverse Anzeige maskieren
         X1              =   1080
         X2              =   1080
         Y1              =   0
         Y2              =   2040
      End
   End
   Begin VB.Line lineH 
      Index           =   0
      X1              =   3840
      X2              =   3840
      Y1              =   240
      Y2              =   2640
   End
   Begin VB.Line lineH 
      Index           =   1
      X1              =   3600
      X2              =   3600
      Y1              =   240
      Y2              =   2640
   End
   Begin VB.Line lineV 
      Index           =   1
      X1              =   120
      X2              =   3360
      Y1              =   2520
      Y2              =   2520
   End
   Begin VB.Line lineV 
      Index           =   0
      X1              =   120
      X2              =   3360
      Y1              =   2280
      Y2              =   2280
   End
End
Attribute VB_Name = "frmColorPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

Dim lngDesktopHwnd As Long
Dim lngDesktopHdc As Long
Dim lngPixelHeight As Long
Dim lngPixelWidth As Long

lngPixelHeight = Screen.Height / Screen.TwipsPerPixelY
lngPixelWidth = Screen.Width / Screen.TwipsPerPixelX


Me.Top = 0
Me.Left = 0
Me.Width = Screen.Width
Me.Height = Screen.Height

lngDesktopHwnd = GetDesktopWindow
lngDesktopHdc = GetDC(lngDesktopHwnd)

'andere Fenster mit AlwaysOnTop-Funktion werden in den Hintergrund gedrngt
SetWindowPos hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE

BitBlt Me.hdc, 0, 0, lngPixelWidth, lngPixelHeight, lngDesktopHdc, 0, 0, SRCCOPY
Me.Refresh

End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

Dim lngFarbe As Long
lngFarbe = GetPixel(Me.hdc, x / Screen.TwipsPerPixelX, y / Screen.TwipsPerPixelY)
frmMain.picFarbe.BackColor = lngFarbe
frmMain.lblRGB.caption = "#" & ColorToHTML(lngFarbe)
frmMain.lblRGB.ForeColor = FarbeUmkehren(lngFarbe)
frmMain.ActiveForm.Paste frmMain.lblRGB.caption
Unload Me

End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

Dim lngPixelX As Long
Dim lngPixelY As Long
Dim lngPixelWidth As Long
Dim lngPixelHeight As Long

lngPixelX = x / Screen.TwipsPerPixelX
lngPixelY = y / Screen.TwipsPerPixelX

lngPixelWidth = picLupe.Width / Screen.TwipsPerPixelX
lngPixelHeight = picLupe.Height / Screen.TwipsPerPixelY

lineV(0).X1 = x - 100
lineV(0).Y1 = y
lineV(0).X2 = x - Me.Width
lineV(0).Y2 = y

lineV(1).X1 = x + 100
lineV(1).Y1 = y
lineV(1).X2 = Me.Width
lineV(1).Y2 = y

lineH(0).X1 = x
lineH(0).Y1 = y - 100
lineH(0).X2 = x
lineH(0).Y2 = 0

lineH(1).X1 = x
lineH(1).Y1 = y + 100
lineH(1).X2 = x
lineH(1).Y2 = y + 10000000

StretchBlt picLupe.hdc, 0, 0, lngPixelWidth, lngPixelHeight, Me.hdc, lngPixelX - 10, lngPixelY - 10, 20, 20, SRCCOPY
picLupe.Refresh

End Sub

Private Sub picLupe_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

If picLupe.Top = 0 And picLupe.Left = 0 Then
    picLupe.Move 0, Me.Height - picLupe.Height
Else: picLupe.Move 0, 0
End If

End Sub
